'use strict'
util = require 'util'
Etcd = require 'node-etcd'
HubotEtcdBrainListener = require './listener'

configureHubotEtcdBrain = (robot) ->
  brainKey = process.env.HUBOT_ETCD_BRAIN_KEY or '/hubot-brain/brain-dump'
  etcdHost = process.env.HUBOT_ETCD_HOST or 'localhost'
  etcdPort = parseInt(process.env.HUBOT_ETCD_PORT or 4001)
  sslOpts = null

  if process.env.HUBOT_ETCD_CA_FILE and
       process.env.HUBOT_ETCD_CERT_FILE and
       process.env.HUBOT_ETCD_KEY_FILE
    sslOpts = {
      ca: [fs.readFileSync(process.env.HUBOT_ETCD_CA_FILE)]
      cert: fs.readFileSync(process.env.HUBOT_ETCD_CERT_FILE)
      key: fs.readFileSync(process.env.HUBOT_ETCD_KEY_FILE)
    }

  etcdClient = new Etcd(etcdHost, etcdPort, sslOpts)
  listener = new HubotEtcdBrainListener(brainKey, etcdClient, robot)
  robot.on 'started', ->
    listener.on 'saved', ->
      robot.logger.debug('hubot-etcd-brain saved')
  listener

module.exports = configureHubotEtcdBrain
