'use strict'
{EventEmitter} = require 'events'
path = require 'path'
util = require 'util'

class HubotEtcdBrainListener extends EventEmitter
  constructor: (@brainKey, @client, @robot) ->
    listener = @
    @robot.brain.on 'save', (data) ->
      listener.sync(data)
      listener.emit 'saved', data
    @robot.brain.on 'loaded', (data) ->
      listener.sync(data)
    try
      @loadJSON()
    catch e
      @robot.logger.error(e)

  sync: (data) ->
    listener = @
    @client.set @brainKey, JSON.stringify(data), (err) ->
      if err
        listener.robot.logger.error(err)
    @emit 'synced', data
    @

  loadJSON: ->
    listener = @
    @client.get @brainKey, (err, payload) ->
      if err?
        listener.robot.logger.error(err)
      else
        value = payload.value
        try
          listener.robot.logger.debug("Raw brain value: #{util.inspect(value)}")
          listener.robot.brain.mergeData(JSON.parse(value))
        catch e
          listener.robot.logger.error(e)
    @emit 'loaded'

module.exports = HubotEtcdBrainListener
